local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local ldbicon = LibStub("LibDBIcon-1.0")
local defaults = {
	['hide'] = false,
}
addon['inits'] = addon['inits'] or {}
addon['ldbs'] = addon['ldbs'] or {}
local secDelay = {}
local function OnText(message, childName)
-- print(message, childName, ldb:GetDataObjectByName(childName))
	if(ldb and ldb:GetDataObjectByName(childName)) then
		ldb:GetDataObjectByName(childName)['text'] = message
		secDelay[childName] = nil
	else
		secDelay[childName] = secDelay[childName] or {
			['count'] = 1,
		}
--		print("del", childName,secDelay[childName]['count'])
		if(secDelay[childName]['count']<3) then
			secDelay[childName]['count'] = secDelay[childName]['count'] + 1
			CreateFrame("Frame"):SetScript("OnUpdate",function(self, el) self.el = self.el and self.el + el or 0; if(self.el>.2) then OnText(message,childName) self:Hide() end end)
		end
	end
end
addon['OnText'] = OnText

addon['ldbiconUpdate'] = function(objname)
	if(ldbicon) then
		local db = addon['db']['global']['ldbicons']
		db[objname] = db[objname] or CopyTable(defaults)
		if(db[objname]['hide']) then
			ldbicon:Hide(objname)
		else
			ldbicon:Show(objname)
		end
	end
end
local function ldbOnClick(self, button)
	local objname = ldb:GetNameByDataObject(self)
	addon['db']['global']['ldbicons'] = addon['db']['global']['ldbicons'] or {}
	local db = addon['db']['global']['ldbicons']
	db[objname] = db[objname] or CopyTable(defaults)
	if(IsShiftKeyDown() and button == "LeftButton") then
		db[objname]['hide'] = not db[objname]['hide']
		addon['ldbiconUpdate'](objname)
	else
		InterfaceOptionsFrame_OpenToCategory(objname)
	end
end

local function OnTooltipShow(self)
	GameTooltip:AddLine(ldb:GetNameByDataObject(self))
end

local function ldbEmbed(tab)
	if(not ldb) then return end
	local objname = tab['name'] or name
--	if(addon['db']['global'][objname.."toggle"]) then return end
-- print("ldbadd",objname)
	local icon = objname ~= name and "Interface\\AddOns\\"..parentName.."\\"..objname.."\\icon2.tga" or "Interface\\AddOns\\"..objname.."\\icon2.tga"
	local ldbobj = ldb:GetDataObjectByName(objname) or ldb:NewDataObject(objname, {
		['type'] = tab['type'] or 'launcher',
		['text'] = objname,
		['icon'] = tab['icon'] or icon,
	})
	ldbobj['OnClick'] = type(tab['OnClick']) == 'function' and function(_, button) tab['OnClick'](ldbobj, button) end or function(_, button) ldbOnClick(ldbobj, button) end
	ldbobj['OnTooltipShow'] = type(tab['OnTooltipShow']) == 'function' and function() tab['OnTooltipShow'](ldbobj) end or function() OnTooltipShow(ldbobj) end
	if(ldbobj and ldbicon) then
		addon['db']['global']['ldbicons'] = addon['db']['global']['ldbicons'] or {}
		local db = addon['db']['global']['ldbicons']
		db[objname] = db[objname] or CopyTable(defaults)
		if(not ldbicon:IsRegistered(objname)) then
			ldbicon:Register(objname,ldbobj,db[objname])
		end
	end
end

local function init()
	for k, v in ipairs(addon['ldbs']) do
		ldbEmbed(v)
	end
end
addon['inits']['ldb'] = addon['inits']['ldb'] or {}
addon['inits']['ldb'][#addon['inits']['ldb'] + 1] = init
