local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_CallMePet"
addon['childs'] = addon['childs'] or {}
addon['childs'][#addon['childs'] + 1] = childName

local blacklist = {
	[49586] = true, -- Gildenpage
	[49588] = true, -- Gildenpage, Horde
	[49587] = true, -- Gildenherold
	[49590] = true, -- Gildenherold, Horde
	[15705] = true, -- Vater Winters kleiner Helfer
	[15698] = true, -- Vater Winters Helfer
--	[33238] = true, -- Argentumknappe
--	[33239] = true, -- Argentumgrunzling
}

local defaults = {
		['autosummon'] = true,
		['dragAble'] = true,
		["IsVisible"] = true,
		['scale'] = 1,
		['currentCritter'] = 1,
		['blacklist'] = blacklist,
}

local options = {
}
local db = {}
local L = LibStub("AceLocale-3.0"):GetLocale(childName)
local delay = GetTime()
local step = 1
addon['inits'] = addon['inits'] or {}
local CallMePetFrame, CallMePetPetFrame, CallMePetPetFrameDice, CallMePetPetFrameLeftArrow, CallMePetPetFrameRightArrow

local function unitCheck(unit)
	return UnitIsDead(unit) or UnitIsGhost(unit) or UnitOnTaxi(unit) or UnitUsingVehicle(unit) or IsMounted(unit)
end

local function setCritter(companiontype, n, clicked, zoned)
	if(GetNumCompanions(companiontype) > 0 and companiontype and n > 0) then
		local creatureID, creatureName, _, _, issummoned = GetCompanionInfo(companiontype, n)
		if(db['blacklist'][creatureID]) then
			local count = GetNumCompanions("CRITTER")
			while(db['blacklist'][creatureID]) do
				n = n + step
				if(n > count) then n = 1 end
				creatureID, creatureName, _, _, issummoned = GetCompanionInfo(companiontype, n)
			end
		end
		db['currentCritter'] = n
		db['currentCritterName'] = creatureName
		if(creatureID) then
			CallMePetPetFrame:SetCreature(creatureID)
			CallMePetPetFrame:ClearAllPoints()
			CallMePetPetFrame:SetPoint("Center",CallMePetFrame,"Center",0,0);
		end
		if((not issummoned or (clicked and not zoned)) and (db['autoSummon'] or clicked) and not unitCheck('player')) then
			CallCompanion(companiontype, n)
		end
	end
end

local function gameButtonClick(event)
	local count = GetNumCompanions("CRITTER")
	if(count > 0) then
		if(event=="RightButton") then
			setCritter("CRITTER", db['currentCritter'],true)
		elseif(event=="next") then
			step  = 1
			db['currentCritter'] = db['currentCritter'] + 1
			if(db['currentCritter'] > count) then
				db['currentCritter'] = 1
			end
			setCritter("CRITTER", db['currentCritter'])
		elseif(event=="prev") then
			step = -1
			db['currentCritter'] = db['currentCritter'] - 1
			if(db['currentCritter'] < 1) then
				db['currentCritter'] = count
			end
			setCritter("CRITTER", db['currentCritter'])
		elseif(event=="dice") then
			local n = random(count)
			setCritter("CRITTER", n,true)
		end
	end
end

local function gameButtonMouseOver(event)
	if(db['currentCritterName']) then
		if(event=="over") then
			GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
			GameTooltip:SetText( format(L["Summon/Dismiss %s"], db['currentCritterName']) )
			GameTooltip:Show()
		else
			GameTooltip:Hide()
		end
	end
end

local function combatToggle(event)
	if(event=="PLAYER_REGEN_ENABLED") then
		if(db['IsVisible'] and db['hideInCombat'] and not CallMePetFrame:IsVisible()) then
			CallMePetFrame:Show()
		end
	else
		if(db['hideInCombat'] and CallMePetFrame:IsVisible()) then
			CallMePetFrame:Hide()
		end	
	end
end

local function zoned()
	if(delay > GetTime()) then return end
	delay = GetTime() + 2
	if(unitCheck('player')) then return end
	if(GetNumCompanions("CRITTER") > 0) then
		local _, _, _, _, issummoned = GetCompanionInfo("CRITTER", db['currentCritter'] or 1)
		if(not issummoned) then
			if(db['randomCritter'] and db['autosummon']) then
				gameButtonClick('dice')
			elseif(db['autosummon']) then
				setCritter("CRITTER", db['currentCritter'],true,true)
			else
				setCritter("CRITTER", db['currentCritter'],false)
			end
		end
	end
end

local function COMPANION_LEARNED()
	local count = GetNumCompanions("CRITTER");
	if(count > 0) then
		for a = 1, count, 1 do
			local _, _, _, _, issummoned = GetCompanionInfo("CRITTER", a)
			if(issummoned) then
				setCritter("CRITTER",a)
				break
			end
		end
	end
end

local function OnEvent(self, event, ...)
	if(event == "PLAYER_REGEN_ENABLED") then
		combatToggle(event)
	elseif(event == "PLAYER_REGEN_DISABLED") then
		combatToggle(event)
	elseif(event == "COMPANION_LEARNED") then
		COMPANION_LEARNED()
	else
		zoned()
	end
end

local function createFrame()
	CallMePetFrame=CreateFrame("FRAME","CallMePetFrame",UIParent);
	CallMePetFrame:SetWidth(72); CallMePetFrame:SetHeight(70);
	CallMePetFrame:SetPoint("Center",UIParent,"Center",0,0);
	CallMePetFrame:SetBackdrop({
	  edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
	  tile=1, tileSize=10, edgeSize=10, 
	  insets={left=3, right=3, top=3, bottom=3}
	})
	CallMePetFrame:SetScript("OnEnter",function() gameButtonMouseOver("over") end)
	CallMePetFrame:SetScript("OnLeave",function() gameButtonMouseOver("out") end)
	CallMePetFrame:SetScript("OnMouseWheel",function(self, dir) Model_OnMouseWheel(CallMePetPetFrame,dir,3,1) end)
	
	CallMePetFrame['locked'] = not db['dragAble']
	addon['loadFrame'](CallMePetFrame)
	addon['addFrameDrag'](CallMePetFrame)
	CallMePetFrame:HookScript("OnMouseUp",function(self, button) gameButtonClick(button) end)
	CallMePetPetFrame=CreateFrame("PlayerModel","CallMePetPetFrame",CallMePetFrame)
	CallMePetPetFrame:SetWidth(64)
	CallMePetPetFrame:SetHeight(64)
	CallMePetPetFrame:SetPoint("Topleft","CallMePetFrame","Topleft",4,-3)
	CallMePetPetFrameDice=CreateFrame("Button","CallMePetPetFrameDice",CallMePetFrame)
	CallMePetPetFrameDice:SetWidth(16); CallMePetPetFrameDice:SetHeight(16)
	CallMePetPetFrameDice:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
	CallMePetPetFrameDice:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
	CallMePetPetFrameDice:SetPoint("Bottomleft","CallMePetFrame","Bottomleft",0,0)
	CallMePetPetFrameDice:SetScript("OnMouseUp",function() gameButtonClick('dice') end)

	CallMePetPetFrameLeftArrow=CreateFrame("Button","CallMePetPetFrameLeftArrow",CallMePetFrame)
	CallMePetPetFrameLeftArrow:SetWidth(16); CallMePetPetFrameLeftArrow:SetHeight(16)
	CallMePetPetFrameLeftArrow:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up")
	CallMePetPetFrameLeftArrow:SetHighlightTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down")
	CallMePetPetFrameLeftArrow:SetPoint("Bottomright","CallMePetFrame","Bottomright",-13,0)
	CallMePetPetFrameLeftArrow:SetScript("OnMouseUp",function() gameButtonClick('prev') end)

	CallMePetPetFrameRightArrow=CreateFrame("Button","CallMePetPetFrameRightArrow",CallMePetFrame)
	CallMePetPetFrameRightArrow:SetWidth(16); CallMePetPetFrameRightArrow:SetHeight(16)
	CallMePetPetFrameRightArrow:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up")
	CallMePetPetFrameRightArrow:SetHighlightTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down")
	CallMePetPetFrameRightArrow:SetPoint("Bottomright","CallMePetFrame","Bottomright",0,0)
	CallMePetPetFrameRightArrow:SetScript("OnMouseUp",function() gameButtonClick('next') end)
	local f = CreateFrame("Frame")
	f:SetScript("OnEvent", OnEvent)
	f:RegisterEvent("PLAYER_CONTROL_GAINED")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:RegisterEvent("PLAYER_ALIVE")
	f:RegisterEvent("PLAYER_UNGHOST")
	f:RegisterEvent("ZONE_CHANGED")
	f:RegisterEvent("ZONE_CHANGED_INDOORS")
	f:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	f:RegisterEvent("COMPANION_LEARNED")
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:RegisterEvent("PLAYER_REGEN_DISABLED")
end

local function getPref2(pref)
	return db['blacklist'][tonumber(strsub(pref[#pref],4))]
end
local function buildLists()
	-- dummyentry
end
local function setPref2(pref,value)
	db['blacklist'][tonumber(strsub(pref[#pref],4))]= (value == true and true or nil)
	buildLists()
end

buildLists = function()
	local count = GetNumCompanions("CRITTER")
	if(count > 0) then
		local petsOption = options['args']['Pets']
		for n = 1, count do
			local creatureID, creatureName, _, _, issummoned = GetCompanionInfo("CRITTER", n)
			if(creatureID) then
				petsOption['args']["Pet"..creatureID] = {
					['name'] = addon['colorize'](creatureName, db['blacklist'][creatureID] and "ff0000" or "ffffff"),
					['type'] = "toggle",
					['get'] = getPref2,
					['set'] = setPref2,
				}
			end
		end
	end
end


local function buildConfig()
	addon['AddConfigEntry']("toggle","IsVisible",L['Visible'],L['Toggle visibility'],1,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry']("toggle","dragAble",L['Dragable'],L['This unlocks the pet display'],1,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry']("toggle","autosummon",L['Autosummon'],L['Automaticly summon your pet'],1,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry']("toggle","randomCritter",L['Random Critter'],L['Automaticly summon a random pet'],1,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry']("range","scale",L['Scale'],L['Scale Interface'],3,0.25,2,0.01,true,options['args'][childName])
	addon['AddConfigEntry']("toggle","hideInCombat",L['Hide in Combat'],L['Hide the pet display in combat'],2,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigMenu']({
		['name'] = 'Pets',
		['order'] = 2,
		['childGroups'] = 'tree',
		['args'] = {},
	}, options)
	buildLists()
end

local function scaleUI(n)
	if(n) then
		CallMePetFrame:SetScale(n)
	end
end

local function OnText(message)
	addon['OnText'](message, childName)
end

local function getPref(pref)
	return db[pref[#pref]]
end

local function setPref(pref,value)
	db[pref[#pref]] = value
	if(pref[#pref]=="scale") then
		scaleUI(db['scale'])
	elseif(pref[#pref]=="dragAble") then
		CallMePetFrame['locked'] = not value
	elseif(pref[#pref]=="IsVisible") then
		if(db['IsVisible']) then
			CallMePetFrame:Show()
		else
			CallMePetFrame:Hide()
		end
	end
end

local function OnClick(self, button, ...)
	if(button == 'LeftButton') then
		if(IsShiftKeyDown()) then
			gameButtonClick('prev')
		else
			gameButtonClick('next')
		end
		gameButtonClick('RightButton')
	else
		InterfaceOptionsFrame_OpenToCategory(childName)
	end
end

local function init()
--	print("init",childName)
	addon['ldbs'][#addon['ldbs'] + 1] = {
		['name'] = childName,
		['type'] = "launcher",
		['OnClick'] = OnClick,
	}
	options = addon['setupPrefs'](childName, parentName, addon['db'], defaults, false, getPref, setPref)
	db = addon['db']['profile'][childName]
	db['blacklist'] = db['blacklist'] or CopyTable(blacklist)
	createFrame()
	buildConfig()
	if(GetNumCompanions("CRITTER")) then
		local n = 1
		if(db['currentCritter']) then
			n = db['currentCritter']
		end
		setCritter("CRITTER", n,false)
	end
	if(not db['IsVisible']) then CallMePetFrame:Hide() end
	if(db['scale']) then scaleUI(db['scale']) end
end

addon['inits'][childName] = init